window.addEventListener("load", _SIlinkerLoad, true);
window.addEventListener("unload", _SIlinkerUnLoad, false);

var _SIlinker_patt1 = new RegExp("^http://((www\.)?)((zhurnal|lit|az|det|fan|world|www.foto)\.lib\.ru)/","i");
var _SIlinker_patt2 = new RegExp("((/[a-z0-9]/[a-z0-9_]+/)([^/?#]+\.shtml)?)$","i");
var _SIlinker_patt3 = new RegExp("/(index(vote|date|title|_[0-9]+)?\.shtml)?$","i");

var _SIlinker_prefs = null;

var _SIlinker_DBconn = null;

var _SIlinker_data = [];

var _SIlinker_job = { id:  0, dom: 0, req: null, checked: 0, good: 0};

var _SIlinker_blink = 0;

var _SIlinker_sentry = true;

function _SIlinkerLoad() {
    // initialization code
    
    window.removeEventListener("load", _SIlinkerLoad, true);
    document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", _showSIlinkerItem, false);

    _SIlinker_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.silinker.");
    
    _SIlinkerPrefObserver.register();
    
    //database initialization

    var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
	file.append("silinker.sqlite");  

	var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);
	_SIlinker_DBconn = storageService.openDatabase(file);

	_SIlinkerDBinit();

	_SIlinkerInitData();

	window.setInterval(_SIlinkerJobStart, 60000);
	window.setInterval(_SIlinkerSentry, 70000);
}

function _SIlinkerUnLoad() {
	_SIlinker_DBconn.close();
}


var _SIlinkerPrefObserver = {  
	register: function() {  
     	// First we'll need the preference services to look for preferences.  
     	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
   
		this._branch = prefService.getBranch("extensions.silinker.");  
   
		// Now we queue the interface called nsIPrefBranch2. This interface is described as:    
		// "nsIPrefBranch2 allows clients to observe changes to pref values."  
		this._branch.QueryInterface(Components.interfaces.nsIPrefBranch2);  
   
		// Finally add the observer.  
		this._branch.addObserver("", this, false);  
	},  
   
	unregister: function() {  
    	if (!this._branch) return;  
    	this._branch.removeObserver("", this);  
	},  
   
	observe: function(aSubject, aTopic, aData) {  
    	if(aTopic != "nsPref:changed") return;  
		// aSubject is the nsIPrefBranch we're observing (after appropriate QI)  
		// aData is the name of the pref that's been changed (relative to aSubject)  
		switch (aData) {  
       		case "usetb":  
       		case "usesb":
       		case "sbnew":
       		case "sbblink":
       			_SIlinkerSetTButton();
         	break;  
         	default:
		}  
	}  
}  

function _SIlinkerDBinit() {
	// initialisation and upgrade of database
	
	var dbversion; // 0 - no database, current=3
	if(_SIlinker_DBconn.tableExists('options')) {
		var statement = _SIlinker_DBconn.createStatement("select value from options where name='version'");
		try {
			if(statement.executeStep()) dbversion=parseInt(statement.getUTF8String(0));
			else {
				_SIlinker_DBconn.executeSimpleSQL("DROP TABLE options");
				dbversion=1;
			}
		}
		catch(e) {
			_SIlinker_DBconn.executeSimpleSQL("DROP TABLE options");
			dbversion=1;
		}
		finally {  
			statement.reset();  
		}  
	}
	else if(_SIlinker_DBconn.tableExists('novels')) dbversion=1;
	else dbversion=0;
	
	_SIlinker_DBconn.beginTransaction();
	switch(dbversion) {
		case 0:
			_SIlinker_DBconn.executeSimpleSQL("CREATE TABLE IF NOT EXISTS options (name VARCHAR PRIMARY KEY NOT NULL, value VARCHAR)");
			_SIlinker_DBconn.executeSimpleSQL("CREATE TABLE IF NOT EXISTS domains (id INTEGER PRIMARY KEY NOT NULL, domain VARCHAR NOT NULL, name VARCHAR)");
			_SIlinker_DBconn.executeSimpleSQL("CREATE TABLE IF NOT EXISTS authors (id INTEGER PRIMARY KEY NOT NULL, dom_id INTEGER NOT NULL, path VARCHAR NOT NULL, name VARCHAR, checked DATETIME NOT NULL DEFAULT 0, error BOOL NOT NULL DEFAULT 0, urgent BOOL NOT NULL DEFAULT 0)");
			_SIlinker_DBconn.executeSimpleSQL("CREATE TABLE IF NOT EXISTS folders (id INTEGER PRIMARY KEY NOT NULL, auth_id INTEGER NOT NULL, dom_id INTEGER NOT NULL, name VARCHAR NOT NULL, deleted BOOL NOT NULL DEFAULT 0, urgent BOOL NOT NULL DEFAULT 0)");
			_SIlinker_DBconn.executeSimpleSQL("CREATE TABLE IF NOT EXISTS novels (id INTEGER PRIMARY KEY NOT NULL, fold_id INTEGER, auth_id INTEGER NOT NULL, dom_id INTEGER NOT NULL, path VARCHAR NOT NULL, name VARCHAR, hash VARCHAR, updated BOOL NOT NULL DEFAULT 1, deleted BOOL NOT NULL DEFAULT 0, urgent BOOL NOT NULL DEFAULT 0, upd_date DATETIME NOT NULL DEFAULT 0)");

			_SIlinker_DBconn.executeSimpleSQL("CREATE UNIQUE INDEX IF NOT EXISTS domains_uni ON domains (domain ASC)");
			_SIlinker_DBconn.executeSimpleSQL("CREATE UNIQUE INDEX IF NOT EXISTS authors_uni ON authors (dom_id ASC, path ASC)");
			_SIlinker_DBconn.executeSimpleSQL("CREATE UNIQUE INDEX IF NOT EXISTS folders_uni ON folders (auth_id ASC, name ASC)");
			_SIlinker_DBconn.executeSimpleSQL("CREATE UNIQUE INDEX IF NOT EXISTS novels_uni ON novels (auth_id ASC, path ASC)");

			_SIlinker_DBconn.executeSimpleSQL("CREATE INDEX IF NOT EXISTS novels_ord1 ON novels (dom_id ASC)");
			_SIlinker_DBconn.executeSimpleSQL("CREATE INDEX IF NOT EXISTS novels_ord2 ON novels (fold_id ASC)");

			_SIlinker_DBconn.executeSimpleSQL("CREATE VIEW IF NOT EXISTS authors_list AS select authors.id, authors.dom_id, domains.domain, authors.path, authors.checked from authors join domains on authors.dom_id=domains.id");
			_SIlinker_DBconn.executeSimpleSQL("CREATE VIEW IF NOT EXISTS novels_list AS select folders.dom_id, folders.auth_id, folders.name as folder, novels.path, novels.name, novels.hash from folders join novels on novels.fold_id=folders.id");
			_SIlinker_DBconn.executeSimpleSQL("CREATE VIEW IF NOT EXISTS novels_urls AS select novels.id, domains.domain, authors.path, novels.path as file from novels join authors, domains on novels.auth_id=authors.id and authors.dom_id=domains.id");
			_SIlinker_DBconn.executeSimpleSQL("CREATE VIEW IF NOT EXISTS display_list AS select id as id0, 0 as id1, 0 as id2, 0 as id3, id, 0 as level, name, (select sum(updated) from novels where dom_id=domains.id) as updated, (select max(error) from authors where dom_id=domains.id) as error, 0 as urgent, (select max(upd_date) from novels where dom_id=domains.id) as upd_date from domains union select dom_id as id0, id as id1, 0 as id2, 0 as id3, id, 1 as level, name , (select sum(updated) from novels where auth_id=authors.id) as updated, error, urgent, (select max(upd_date) from novels where auth_id=authors.id) as upd_date from authors union select dom_id as id0, auth_id as id1, id as id2, 0 as id3, id, 2 as level, name, (select sum(updated) from novels where fold_id=folders.id) as updated, 0 as error, urgent, (select max(upd_date) from novels where fold_id=folders.id) as upd_date from folders union select dom_id as id0, auth_id as id1, fold_id as id2, id as id3, id, 3 as level, name, updated, 0 as error, urgent, upd_date from novels order by id0, id1, id2, id3");

			_SIlinker_DBconn.executeSimpleSQL("CREATE TRIGGER IF NOT EXISTS authors_delete1 AFTER DELETE ON authors BEGIN delete from folders where auth_id=old.id; delete from novels where auth_id=old.id; END");
			_SIlinker_DBconn.executeSimpleSQL("CREATE TRIGGER IF NOT EXISTS authors_delete2 AFTER DELETE ON authors WHEN (select count(*) from authors where dom_id=old.dom_id)=0 BEGIN delete from domains where id=old.dom_id; END");
			_SIlinker_DBconn.executeSimpleSQL("CREATE TRIGGER IF NOT EXISTS authors_insert INSTEAD OF INSERT ON authors_list BEGIN insert or ignore into domains (domain,name) values (new.domain,new.domain); insert or ignore into authors (dom_id,path,name) values ((select id from domains where domain=new.domain),new.path,new.path); END");
			_SIlinker_DBconn.executeSimpleSQL("CREATE TRIGGER IF NOT EXISTS authors_update AFTER UPDATE OF name, error ON authors BEGIN update authors set checked=datetime('now','-30 seconds') where id=old.id; END");

			_SIlinker_DBconn.executeSimpleSQL("CREATE TRIGGER IF NOT EXISTS novels_insert INSTEAD OF INSERT ON novels_list BEGIN insert or ignore into folders (auth_id,dom_id,name,urgent) values (new.auth_id,new.dom_id,new.folder,(select urgent from authors where authors.id=new.auth_id)); insert or ignore into novels (auth_id,dom_id,path,urgent) values (new.auth_id,new.dom_id,new.path,(select urgent from folders where folders.auth_id=new.auth_id and folders.name=new.folder)); update novels set fold_id=(select id from folders where auth_id=new.auth_id and name=new.folder), name=new.name, hash=new.hash, deleted=0 where auth_id=new.auth_id and path=new.path; END");
			_SIlinker_DBconn.executeSimpleSQL("CREATE TRIGGER IF NOT EXISTS novels_update1 AFTER UPDATE OF hash ON novels WHEN old.hash IS NOT new.hash BEGIN update novels set updated=1, upd_date=datetime('now') where id=new.id; END");
			_SIlinker_DBconn.executeSimpleSQL("CREATE TRIGGER IF NOT EXISTS novels_update2 AFTER UPDATE OF deleted ON novels WHEN new.deleted=0 BEGIN update folders set deleted=0 where id=new.fold_id; END");

			break;
			
		case 1:
			_SIlinker_DBconn.executeSimpleSQL("ALTER TABLE authors ADD COLUMN urgent BOOL NOT NULL DEFAULT 0");
			
			_SIlinker_DBconn.executeSimpleSQL("ALTER TABLE folders ADD COLUMN urgent BOOL NOT NULL DEFAULT 0");
			
			_SIlinker_DBconn.executeSimpleSQL("ALTER TABLE novels ADD COLUMN urgent BOOL NOT NULL DEFAULT 0");
			_SIlinker_DBconn.executeSimpleSQL("ALTER TABLE novels ADD COLUMN upd_date DATETIME NOT NULL DEFAULT 0");
			_SIlinker_DBconn.executeSimpleSQL("UPDATE novels SET upd_date=datetime('now')");
			
			_SIlinker_DBconn.executeSimpleSQL("CREATE INDEX IF NOT EXISTS novels_ord1 ON novels (dom_id ASC)");
			_SIlinker_DBconn.executeSimpleSQL("CREATE INDEX IF NOT EXISTS novels_ord2 ON novels (fold_id ASC)");

			_SIlinker_DBconn.executeSimpleSQL("DROP VIEW IF EXISTS display_list");
			_SIlinker_DBconn.executeSimpleSQL("CREATE VIEW display_list AS select id as id0, 0 as id1, 0 as id2, 0 as id3, id, 0 as level, name, (select sum(updated) from novels where dom_id=domains.id) as updated, (select max(error) from authors where dom_id=domains.id) as error, 0 as urgent, (select max(upd_date) from novels where dom_id=domains.id) as upd_date from domains union select dom_id as id0, id as id1, 0 as id2, 0 as id3, id, 1 as level, name , (select sum(updated) from novels where auth_id=authors.id) as updated, error, urgent, (select max(upd_date) from novels where auth_id=authors.id) as upd_date from authors union select dom_id as id0, auth_id as id1, id as id2, 0 as id3, id, 2 as level, name, (select sum(updated) from novels where fold_id=folders.id) as updated, 0 as error, urgent, (select max(upd_date) from novels where fold_id=folders.id) as upd_date from folders union select dom_id as id0, auth_id as id1, fold_id as id2, id as id3, id, 3 as level, name, updated, 0 as error, urgent, upd_date from novels order by id0, id1, id2, id3");

			_SIlinker_DBconn.executeSimpleSQL("DROP TRIGGER IF EXISTS authors_update");
			_SIlinker_DBconn.executeSimpleSQL("CREATE TRIGGER authors_update AFTER UPDATE OF name, error ON authors BEGIN update authors set checked=datetime('now','-30 seconds') where id=old.id; END");

			_SIlinker_DBconn.executeSimpleSQL("DROP TRIGGER IF EXISTS novels_update1");
			_SIlinker_DBconn.executeSimpleSQL("CREATE TRIGGER novels_update1 AFTER UPDATE OF hash ON novels WHEN old.hash IS NOT new.hash BEGIN update novels set updated=1, upd_date=datetime('now') where id=new.id; END");

			_SIlinker_DBconn.executeSimpleSQL("CREATE TABLE IF NOT EXISTS options (name VARCHAR PRIMARY KEY NOT NULL, value VARCHAR)");

		case 2:	
			_SIlinker_DBconn.executeSimpleSQL("DROP TRIGGER IF EXISTS novels_insert");
			_SIlinker_DBconn.executeSimpleSQL("CREATE TRIGGER novels_insert INSTEAD OF INSERT ON novels_list BEGIN insert or ignore into folders (auth_id,dom_id,name,urgent) values (new.auth_id,new.dom_id,new.folder,(select urgent from authors where authors.id=new.auth_id)); insert or ignore into novels (auth_id,dom_id,path,urgent) values (new.auth_id,new.dom_id,new.path,(select urgent from folders where folders.auth_id=new.auth_id and folders.name=new.folder)); update novels set fold_id=(select id from folders where auth_id=new.auth_id and name=new.folder), name=new.name, hash=new.hash, deleted=0 where auth_id=new.auth_id and path=new.path; END");
			
		case 3:
	}
		
	if(dbversion!=3) 
		_SIlinker_DBconn.executeSimpleSQL("INSERT OR REPLACE INTO options (name,value) values ('version','3')");

	_SIlinker_DBconn.commitTransaction();
}

function _SIlinkerInitData() {
	// get full dataset
	
	_SIlinker_data = _SIlinkerGetData(0,0);
	_SIlinkerSetTButton();
}

function _SIlinkerSetTButton() {
	// set state of toolbar button (and statusbar icon)
	
	var i = 0;
	var data = _SIlinker_data;
	var updated = 0;
	
	while(i<data.length)
	{
		if(data[i].updated) {
			updated = 1;
			break;
		}
		i++;
	}
	
	document.getElementById("silinker-open-upd").disabled=!updated;
	
	var usetb = _SIlinker_prefs.getBoolPref("usetb");
	var tbutton = document.getElementById("silinker-button");
	if(tbutton) {
		tbutton.setAttribute('updated', usetb ? updated : 1);
	}
	
	var usesb = _SIlinker_prefs.getBoolPref("usesb");
	var sbnew = usesb && _SIlinker_prefs.getBoolPref("sbnew");
	var sbblink = usesb && _SIlinker_prefs.getBoolPref("sbblink");
	var sbp = document.getElementById("silinker-panel");
	if(sbp) {
		sbp.hidden = (!usesb)||(sbnew&&(!updated));
		sbp.image='chrome://silinker/skin/icon_small'+(updated ? '_upd' : '')+'.png';
	}
	
	if((!updated)||(!sbblink)) _SIlinker_blink=0;
}

function _SIlinkerBlinker() {
	// blinking of statusbar icon

	var sbp = document.getElementById("silinker-panel");
	if(sbp) {
		switch(_SIlinker_blink) {
			case 0:
				break;
			case 1:
				sbp.image='chrome://silinker/skin/icon_small_upd.png';
				_SIlinker_blink=2;
				window.setTimeout(_SIlinkerBlinker,600);
				break;
			case 2:
				sbp.image='';
				_SIlinker_blink=3;
				window.setTimeout(_SIlinkerBlinker,200);
				break;
			case 3:
				sbp.image='chrome://silinker/skin/icon_small_upd.png';
				_SIlinker_blink=4;
				window.setTimeout(_SIlinkerBlinker,200);
				break;
			case 4:
				sbp.image='';
				_SIlinker_blink=1;
				window.setTimeout(_SIlinkerBlinker,200);
				break;
			case 5:
				sbp.image='chrome://silinker/skin/icon_small_upd.png';
				_SIlinker_blink=0;
				break;
		}
	}
}

function _SIlinkerSBclick(event) {
	// click on statusbar icon

	if(_SIlinker_blink!=0) _SIlinker_blink=5;
	else if(event.button==0) toggleSidebar('viewSidebar_SIlinker');
}

function _SIlinkerGeneratePopup(event) {
	//copy the stuff from the primary popup
	
	var popup = event.target;
	var primary = document.getElementById("silinker-panel-menu");
  	
  	for (var i = 0; i < primary.childNodes.length; i++) {
    	popup.appendChild(primary.childNodes[i].cloneNode(true));
	}
}

function _SIlinkerClearMenu(event) {
	// clear menu
	
	var popup = event.target;
	
	while (popup.hasChildNodes()) {
		popup.removeChild(popup.firstChild);
	}
}

function _SIlinkerSortById (a,b) {

	return a.id-b.id;
}

function _SIlinkerSortByDate (a,b) {

	var diff=b.upd_date.getTime()-a.upd_date.getTime();
	return (diff!=0) ? diff : b.id-a.id;
}

function _SIlinkerSortByName (a,b) {

	return (a.name>b.name) ? 1 : ((a.name<b.name) ? -1 : 0);
}

function _SIlinkerSetSortFunc() {

	switch(_SIlinker_prefs.getCharPref("sortord")) {
		case 'byname':
			return _SIlinkerSortByName;
		case 'bydate':
			return _SIlinkerSortByDate;
		case 'byid':
		default:
			return _SIlinkerSortById;
	}
}

function _SIlinkerGetData(dom_id, auth_id) {
	// get data and organize it

	var onlynew = _SIlinker_prefs.getBoolPref("shownew");
	
	var i = 0;
	var data = [];
	var condition = '';
	
	if(dom_id) {
		condition+='(id0='+dom_id+')';
		if(auth_id)	condition+='(id1=0 or id1='+auth_id+')';
	}
	if(onlynew) condition+='(level=0 or error=1 or updated>0)';
	if(condition>'') condition=' where '+condition.replace(/\)\(/g,') and (');
	
	var statement = _SIlinker_DBconn.createStatement("select * from display_list"+condition);
	try {
		while(statement.executeStep()) {
			data[i++]={ id:		  statement.getInt64(4),
					  	level:	  statement.getInt32(5),
					    name:	  statement.getUTF8String(6),
					    updated:  statement.getInt32(7),
					    error:	  statement.getInt32(8),
						urgent:	  statement.getInt32(9),
					    upd_date: new Date(statement.getUTF8String(10).replace(/^(\d{4}-\d{2}-\d{2}) (\d{2}:\d{2}:\d{2}).*/,'$1T$2Z')),
					    open:	  true,
					    updating: false,
					    pocket:	  null
					  };
		}
	}
	finally {  
		statement.reset();  
	}  

	var level_0 = [];
	var level_1 = [];
	var level_2 = [];
	var level_3 = [];

	var sort_func=_SIlinkerSetSortFunc();
	
	while(data.length>0) {
		var el=data.pop();
		switch(el.level) {
			case 3:
				level_3.push(el);
				break;
			case 2:
				if(level_3.length>0) el.pocket=level_3.sort(sort_func);
				el.open=false;
				level_3=[];
				level_2.push(el);
				break;
			case 1:
				if(level_2.length>0) el.pocket=level_2.sort(sort_func);
				el.open=false;
				level_2=[];
				level_1.push(el);
				break;
			case 0:
				if(level_1.length>0) el.pocket=level_1.sort(sort_func);
				el.open=false;
				level_1=[];
				level_0.push(el);
				break;
		}
	}
	data = level_0.sort(sort_func);
	
	i = 0;
	while(i<data.length) {
		if(data[i].updated||(data[i].error&&(data[i].level==0))) {
			if(data[i].pocket) {
				var pocket=data[i].pocket;
				var j=i+1;
				var k=0;
				while(k<pocket.length) data.splice(j++,0,pocket[k++]);
				data[i].pocket=null;
			}
			data[i].open=true;
		}
		i++;
	}
	
	return data;
}

function _showSIlinkerItem() {
    // show or hide the menuitem based on what the context menu is on
    
    var ShowItem = false;
	var ShowItem2= false;
	var ShowItem3= false;
	var ShowItem4= false;

	var isLink = gContextMenu.onLink;
	var aURL = isLink ? gContextMenu.linkURL : gContextMenu.target.ownerDocument.documentURI;
	var aPage = gContextMenu.target.ownerDocument.documentURI;
	
	var arr1 = _SIlinker_patt1.exec(aURL);
	var arr2 = _SIlinker_patt2.exec(aURL);
	
	if(arr1 && arr2) {
		var url= arr1[3] + arr2[1];
		gContextMenu._SIlinker_url = url;
		ShowItem=isLink && (!_SIlinker_patt3.test(aURL));
		ShowItem2=isLink;

		var statement = _SIlinker_DBconn.createStatement("select id from authors_list where domain='"+arr1[3]+"' and path='"+arr2[2]+"'"); 
		try {
			if(!statement.executeStep()) {
				ShowItem3=isLink;
				ShowItem4=!isLink;
			}
		}
		finally {  
			statement.reset();  
		}  
		
		var arr3 = _SIlinker_patt1.exec(aPage);
		
		if(arr3) {
			ShowItem3=false;
			var arr4 = _SIlinker_patt2.exec(aPage);
			if(arr4) {
				if((arr1[3]==arr3[3])&&(arr2[2]==arr4[2])) ShowItem2=false;
			}
		}
	}

	var ShowItem5 = ShowItem || ShowItem2 || ShowItem3 || ShowItem4;
	
	gContextMenu.showItem("context-silinker", ShowItem);
	gContextMenu.showItem("context-silinker-open", ShowItem2);
	gContextMenu.showItem("context-silinker-storelink", ShowItem3);
	gContextMenu.showItem("context-silinker-storepage", ShowItem4);
	gContextMenu.showItem("context-sep-silinker", ShowItem5);	
}

function _SIlinkerOpenTab(aURL,aBkg) {
	//open given URL in new tab
	
	var aDocument=gContextMenu ? gContextMenu.target.ownerDocument : null;
	if (aDocument) urlSecurityCheck(aURL, aDocument.nodePrincipal);

	// open link in new tab
  	var referrerURI = aDocument ? aDocument.documentURIObject : null;
  	var browser = top.document.getElementById("content");
  	browser.loadOneTab(aURL, referrerURI, null, null, aBkg, false);
}
  
function _SIlinkerGetUrl(aFull) {
	// get url, full or truncated

  	//check if mirror needed
	var mirr = _SIlinker_prefs.getBoolPref("usemirr");
	var url = gContextMenu._SIlinker_url;
	
	if(mirr) {
		if(url.substr(0,7)=="zhurnal") {
			url = "www.foto" + url.substr(7);
		}
	}
	else {
		if(url.substr(0,8)=="www.foto") {
			url = "zhurnal" + url.substr(8);
		}
	}
	
	if(!aFull) url = url.substr(0,url.lastIndexOf('/')+1);
	
	return "http://" + url;
}

function _SIlinkerCommand(aBkg) {
  	// open in new tab in SI-reader

    var url=_SIlinkerGetUrl(true);
    
    _SIlinkerOpenNovel(url,aBkg);
    
    url=url.substr(7);
    var idx=url.indexOf('/');
    var domain=url.substr(0,idx);
    url=url.substr(idx);
    idx=url.lastIndexOf('/')+1;
    var path=url.substr(0,idx);
    var file=url.substr(idx);
   	var statement1 = _SIlinker_DBconn.createStatement("select id from novels_urls where domain='"+domain+"' and path='"+path+"' and file='"+file+"'"); 
	try {
		if(statement1.executeStep()) {
			var id=statement1.getInt64(0);
			_SIlinker_DBconn.executeSimpleSQL("update novels set updated=0 where id="+id);
			var statement2 = _SIlinker_DBconn.createStatement("select dom_id, auth_id from novels where id="+id);
			try {
				if(statement2.executeStep()) {
					var dom_id=statement2.getInt64(0);
					var auth_id=statement2.getInt64(1);
					_SIlinkerUpdateBranch(dom_id,auth_id);
				}
			}
			finally {  
				statement2.reset();  
			}  
		}
	}
	finally {  
		statement1.reset();  
	}  
}

function _SIlinkerOpenNovel(url,aBkg) {
  	// open in new tab in SI-reader
  	
  	//get site address
	var site = _SIlinker_prefs.getCharPref("siteaddr");
    var aURL="http://" + site + "/rider/?hfile=";
    
    for(var i=0;i<url.length;i++) {
    	aURL+=url.charCodeAt(i).toString(16)
    }
    
    aURL+='&silinker';

	_SIlinkerOpenTab(aURL,aBkg);
}
  
function _SIlinkerOpenAuthor(aBkg) {
  	// open author page in new tab

	var aURL=_SIlinkerGetUrl(false);
	
	_SIlinkerOpenTab(aURL,aBkg);
}

function _SIlinkerStore() {
	// store link adress or page address 
	
	var url=_SIlinkerGetUrl(false).substr(7);
	var idx=url.indexOf('/');
    var domain = url.substr(0,idx);
    var path =  url.substr(idx);
    
	_SIlinker_DBconn.executeSimpleSQL("insert into authors_list (domain,path) values ('"+domain+"','"+path+"')");
	window.setTimeout(_SIlinkerJobStart,10);
}

function _SIlinkerUpdateBranch(dom_id,auth_id) {
	// get domain-author-... branch and insert it
	
	var branch = _SIlinkerGetData(dom_id,auth_id);
	var data = _SIlinker_data;
	var pos = _SIlinkerGetViewPos();
	var idx = _SIlinkerGetViewIdx();
	
	var sort_func=_SIlinkerSetSortFunc();
	
	var i=-1;
	while(++i<data.length) if((data[i].level==0)&&(data[i].id==dom_id)) break;
	if(i<data.length) {
		var j=i+1;
		while((j<data.length)&&(data[j].level>0)) j++;
		var main_branch=data.splice(i,j-i);
		_SIlinkerUpdateView(i,i-j,-1);

		var node=branch.shift();
		main_branch[0].updated=node.updated;
		main_branch[0].name=node.name;
		main_branch[0].error=node.error;
		main_branch[0].upd_date=node.upd_date;
		if(node.open&&(!main_branch[0].open)) {
			if(main_branch[0].pocket!=null) {
				var pocket=main_branch[0].pocket;
				main_branch[0].pocket=null;
				for(j=0;j<pocket.length;j++) main_branch.splice(j+1,0,pocket[j]);
			}
			main_branch[0].open=true;
		}
		if(node.pocket!=null) branch=node.pocket;
		var tmp;
		if(main_branch[0].pocket!=null) {
			tmp=main_branch[0].pocket;
			i=-1;
		}
		else {
			tmp=main_branch;
			i=0;
		}
		while(++i<tmp.length) if((tmp[i].level==1)&&(tmp[i].id==auth_id)) break;
		if(i<tmp.length) {
			j=i+1;
			while((j<tmp.length)&&(tmp[j].level>1)) j++;
			tmp.splice(i,j-i);
		}
		if(branch.length>0) {
			i=0;
			while((i<tmp.length)&&((tmp[i].level!=1)||(sort_func(branch[0],tmp[i])>=0))) i++;
			for(j=0;j<branch.length;j++) tmp.splice(i+j,0,branch[j]);
		}
		
		branch=main_branch;
	}
	i=0;
	while((i<data.length)&&((data[i].level!=0)||(sort_func(branch[0],data[i])>=0))) i++;
	for(var j=0;j<branch.length;j++) data.splice(i+j,0,branch[j]);
	_SIlinkerUpdateView(i,branch.length,-1);
	_SIlinkerSetViewPos(pos);
	_SIlinkerSetViewIdx(idx);
	_SIlinkerSetTButton();
}

function _SIlinkerUpdateView(from,len,node) {
	// update treeView

	var sidebarWindow = document.getElementById("sidebar").contentWindow;
	if (sidebarWindow.location.href=="chrome://silinker/content/sidebar.xul") {
		if(len!=0)
			sidebarWindow._SIlinker_treeView.treeBox.rowCountChanged(from,len);
		if(node>-1)
			sidebarWindow._SIlinker_treeView.treeBox.invalidateRow(node);
	}
} 

function _SIlinkerGetViewPos() {
	
	var sidebarWindow = document.getElementById("sidebar").contentWindow;
	if (sidebarWindow.location.href=="chrome://silinker/content/sidebar.xul")
		return sidebarWindow._SIlinker_treeView.treeBox.getFirstVisibleRow();
	else
		return 0;
}

function _SIlinkerGetViewIdx() {
	
	var sidebarWindow = document.getElementById("sidebar").contentWindow;
	if (sidebarWindow.location.href=="chrome://silinker/content/sidebar.xul")
		return sidebarWindow.document.getElementById('silinker-tree').currentIndex;
	else
		return -1;
}

function _SIlinkerSetViewPos(pos) {

	var sidebarWindow = document.getElementById("sidebar").contentWindow;
	if (sidebarWindow.location.href=="chrome://silinker/content/sidebar.xul")
		sidebarWindow._SIlinker_treeView.treeBox.scrollToRow(pos);	
}

function _SIlinkerSetViewIdx(idx) {

	var sidebarWindow = document.getElementById("sidebar").contentWindow;
	if (sidebarWindow.location.href=="chrome://silinker/content/sidebar.xul")
		sidebarWindow.document.getElementById('silinker-tree').currentIndex=idx;
}

function _SIlinkerAuthor(id,aBkg) {
	// open author page by id

	var statement = _SIlinker_DBconn.createStatement("select domain||path as url from authors_list where id="+id); 
	try {
		if(statement.executeStep()) {
			_SIlinkerOpenTab("http://"+statement.getUTF8String(0),aBkg);
		}
	}
	finally {  
		statement.reset();  
	}  
}

function _SIlinkerDelAuthor(idx) {
	// delete author
	
	var data=_SIlinker_data;
	
	_SIlinker_DBconn.executeSimpleSQL("delete from authors where id="+data[idx].id);
	
	var j=idx;
	while(++j<data.length) if(data[j].level<=1) break;
	data.splice(idx,j-idx);
	_SIlinkerUpdateView(idx,idx-j,-1);
	if((data[idx-1].level==0)&&((data.length==idx)||(data[idx].level==0))) {
		data.splice(idx-1,1);
		_SIlinkerUpdateView(idx-1,-1,-1);
	}
	_SIlinkerSetTButton();
}

function _SIlinkerDelAll(idx) {
	// delete all authors from specific site
	
	var data=_SIlinker_data;
	
	_SIlinker_DBconn.executeSimpleSQL("delete from authors where dom_id="+data[idx].id);
	var j=idx;
	while(++j<data.length) if(data[j].level==0) break;
	data.splice(idx,j-idx);
	_SIlinkerUpdateView(idx,idx-j,-1);
	_SIlinkerSetTButton();
}

function _SIlinkerSetDump(condition) {
	// set dump panel in statusbar

	var dump = document.getElementById('silinker-panel-dump');
	var showdump = _SIlinker_prefs.getBoolPref("showdump");
	
	if(!showdump) {
		_SIlinker_job.checked=0;
		dump.hidden=true;
		return;
	}
	
	var tocheck, total;

	var statement = _SIlinker_DBconn.createStatement("select count(*) from authors");
	try {
		if(statement.executeStep()) {
			total=statement.getInt32(0);
		}
	}
	finally {  
		statement.reset();  
	}  
	
	statement = _SIlinker_DBconn.createStatement("select count(*) from authors "+condition);
	try {
		if(statement.executeStep()) {
			tocheck=statement.getInt32(0);
		}
	}
	finally {  
		statement.reset();  
	}
	
	if(tocheck==0) _SIlinker_job.checked=0;
	dump.label=tocheck+'/'+_SIlinker_job.checked+'/'+total;
	dump.hidden=(tocheck==0);
}

function _SIlinkerSentry() {
	// check and reset if silinker job cycle hangs
	
	if(_SIlinker_sentry) {
		_SIlinker_sentry=false;
	}
	else {
		if(_SIlinker_job.req) {
			_SIlinker_job.req.abort();
			_SIlinker_job.req=null;
		}
   		_SIlinker_DBconn.beginTransaction();
   		_SIlinker_DBconn.executeSimpleSQL("update authors set error=1 where id="+_SIlinker_job.id);	
		_SIlinker_DBconn.executeSimpleSQL("update folders set deleted=0 where auth_id="+_SIlinker_job.id);
   		_SIlinker_DBconn.executeSimpleSQL("update novels set deleted=0 where auth_id="+_SIlinker_job.id);
   		_SIlinker_DBconn.commitTransaction();
		if(_SIlinker_job.id) _SIlinkerUpdateBranch(_SIlinker_job.dom,_SIlinker_job.id);
		_SIlinker_job.id=0;
		_SIlinker_job.txt=null;
		_SIlinker_job.reg=null;
		_SIlinker_job.good=0;
	}
}

function _SIlinkerMarkUpd(dom,id) {
	// mark updating author
	
	var data=_SIlinker_data;
	var i = 0;
	var visible = true;
	
	while((i<data.length)&&((data[i].level!=0)||(data[i].id!=dom))) i++;
	if(i<data.length) {
		if(data[i].pocket) {
			data=data[i].pocket;
			i=0;
			visible=false;
		}
		while((i<data.length)&&((data[i].level!=1)||(data[i].id!=id))) i++;
		if(i<data.length) {
			data[i].updating=true;
			if(visible) _SIlinkerUpdateView(i,0,i);
		}
	}
}

function _SIlinkerJobStart() {
	// start author page loading
	
	if(_SIlinker_job.id>0){
		window.setTimeout(_SIlinkerJobStart,1000);
		return;
	}
	
	_SIlinker_sentry = true;
	
	var useperiod = _SIlinker_prefs.getBoolPref("useperiod");
	var period = _SIlinker_prefs.getIntPref("period");
	var condition = "where checked"+(useperiod ? "<=datetime('now','-"+period+" hours') order by checked asc" : "=0");
	_SIlinkerSetDump(condition);
	var statement = _SIlinker_DBconn.createStatement("select id, dom_id, domain||path as url from authors_list "+condition+" limit 1");
	try {
		if(statement.executeStep()) {
			_SIlinker_job.id=statement.getInt64(0);
			_SIlinker_job.dom=statement.getInt64(1);
			_SIlinker_job.req=new XMLHttpRequest();
			_SIlinker_job.req.open('GET','http://'+statement.getUTF8String(2)+'indexdate.shtml',true);
			_SIlinker_job.req.onreadystatechange=_SIlinkerJob;
			_SIlinker_job.req.send(null);
			_SIlinkerMarkUpd(_SIlinker_job.dom,_SIlinker_job.id);
		}
		else _SIlinker_job.good=0;
	}
	finally {  
		statement.reset();  
	}  
}

function _SIlinkerJob(aEvt) {
	// do the author checking

	_SIlinker_sentry = true;
	
	if(_SIlinker_job.req.readyState != 4) return;

	var id=_SIlinker_job.id;
	var dom=_SIlinker_job.dom;
	var error=true;
	
    if(_SIlinker_job.req.status==200) {
    	var txt=_SIlinker_job.req.responseText;
    	var arr=txt.match(/<title>(.+?)\.(?![a-z])\s*([^<]+?)\s*<.title>/);
    	if(arr) {
    		var name=arr[2];
    		var site=arr[1].replace(/&quot;/g,'"');

    		_SIlinker_DBconn.beginTransaction();
   			_SIlinker_DBconn.executeSimpleSQL("update domains set name='"+site+"' where id="+dom);
   			_SIlinker_DBconn.executeSimpleSQL("update authors set name='"+name+"', error=0 where id="+id);
   			_SIlinker_DBconn.executeSimpleSQL("update folders set deleted=1 where auth_id="+id);
   			_SIlinker_DBconn.executeSimpleSQL("update novels set deleted=1 where auth_id="+id);
    		_SIlinker_DBconn.commitTransaction();

			var statement=_SIlinker_DBconn.createStatement("select sum(updated) from novels where auth_id="+id);
			try {
				if(statement.executeStep()) {
					_SIlinker_job.cnt=statement.getInt32(0);
				}
			}
			finally {  
				statement.reset();  
			}  	

   			_SIlinker_job.txt=txt;
   			_SIlinker_job.reg= /^<DL><DT><li>.*?<A HREF=([^>]+\.shtml)>(.+?)&nbsp;(.+?)&nbsp;[^"]*\s"[@*]*([^"]+)".+?<br>((<DD>)?.*?)(<.DL>|<DD>)$/gm;
   			_SIlinker_job.err=true;
   			window.setTimeout(_SIlinkerJobLong,50);
   			error=false;
   		}
	}
	
	if(error) {
		_SIlinker_DBconn.executeSimpleSQL("update authors set error=1 where id="+id);	
		_SIlinkerUpdateBranch(dom,id);
		_SIlinker_job.id=0;
		_SIlinker_job.checked++;
	}

	_SIlinker_job.req=null;
}

function _SIlinkerJobLong() {
	// long job of parsing author page for novels

	_SIlinker_sentry = true;
	
	var id=_SIlinker_job.id;
	var dom=_SIlinker_job.dom;
    
    var arr=_SIlinker_job.reg.exec(_SIlinker_job.txt);
	if(arr) {
		var path=arr[1];
    	var name=arr[2];
    	var hash=arr[2]+arr[3];
    	if(arr[5].substr(0,4)=='<DD>') hash+=arr[5];
    	var folder=arr[4];

    	name=name.replace(/<.+?>/g,' ').replace(/^\s+/,'').replace(/\s+$/,'').replace(/\s+/g,' ');
    	hash=hash.replace(/<.+?>/g,' ').replace(/^\s+/,'').replace(/\s+$/,'').replace(/\s+/g,' ');
    	var data=[];
    	for(var j=0;j<hash.length;j++) data[j]=hash.charCodeAt(j);
    	var ch = Components.classes["@mozilla.org/security/hash;1"].createInstance(Components.interfaces.nsICryptoHash);
    	ch.init(ch.MD5);
		ch.update(data, data.length);
		hash = ch.finish(true);
		name=name.replace(/'/g,"''");
		_SIlinker_DBconn.executeSimpleSQL("insert into novels_list (dom_id,auth_id,folder,name,path,hash) values ("+dom+","+id+",'"+folder+"','"+name+"','"+path+"','"+hash+"')");
    	_SIlinker_job.err=false;
    	window.setTimeout(_SIlinkerJobLong,50);
	}
	else {

	    if(_SIlinker_job.err) {
    		_SIlinker_DBconn.beginTransaction();
    		_SIlinker_DBconn.executeSimpleSQL("update authors set error=1 where id="+id);	
			_SIlinker_DBconn.executeSimpleSQL("update folders set deleted=0 where auth_id="+id);
    		_SIlinker_DBconn.executeSimpleSQL("update novels set deleted=0 where auth_id="+id);
    		_SIlinker_DBconn.commitTransaction();
    	}
    	else {
    		_SIlinker_DBconn.beginTransaction();
			_SIlinker_DBconn.executeSimpleSQL("delete from folders where deleted=1 and auth_id="+id);
    		_SIlinker_DBconn.executeSimpleSQL("delete from novels where deleted=1 and auth_id="+id);
    		if(_SIlinker_job.good==1) _SIlinker_DBconn.executeSimpleSQL("update authors set checked=0 where error=1");
    		_SIlinker_DBconn.commitTransaction();
			
			var statement=_SIlinker_DBconn.createStatement("select sum(updated) from novels where auth_id="+id);
			try {
				if(statement.executeStep()) {
					if(_SIlinker_job.cnt!=statement.getInt32(0))
						_SIlinkerNotify(id);
				}
			}
			finally {  
				statement.reset();  
			}  	
			
			_SIlinker_job.good++;
    	}

		_SIlinker_job.id=0;
		_SIlinker_job.txt=null;
		_SIlinker_job.reg=null;
		_SIlinker_job.checked++;

		_SIlinkerUpdateBranch(dom,id);
		window.setTimeout(_SIlinkerJobStart,100);
	}
}

var _SIlinkerNlistener = {  
	observe: function(subject, topic, data) {
		if(topic=="alertclickcallback") {
			_SIlinkerOpenTab('http://'+data+'indexdate.shtml',false);
		}
	}  
}  

function _SIlinkerNotify(id) {
	// notify about new updates

	if(_SIlinker_prefs.getBoolPref("notify")) {
		var site, author, url;
		var statement=_SIlinker_DBconn.createStatement("select domains.name, authors.name, domains.domain||authors.path from authors left join domains on authors.dom_id=domains.id where authors.id="+id);
		try {
			if(statement.executeStep()) {
					site=statement.getUTF8String(0);
					author=statement.getUTF8String(1);
					url=statement.getUTF8String(2);
			}
		}
		finally {  
			statement.reset();  
		}

		var alertsService = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
		alertsService.showAlertNotification('chrome://silinker/skin/icon.png',site,author,true,url,_SIlinkerNlistener,'');
	}  	

	var usesb = _SIlinker_prefs.getBoolPref("usesb");
	var sbblink = usesb && _SIlinker_prefs.getBoolPref("sbblink");
	if(sbblink&&(_SIlinker_blink==0)) {
		_SIlinker_blink=1;
		window.setTimeout(_SIlinkerBlinker,10);
	}
}

function _SIlinkerClear(id,level) {
	// clear 'updated' flag
	
	var col;
	
	switch(level) {
		case 0: col='dom_id'; break;
		case 1: col='auth_id'; break;
		case 2: col='fold_id'; break;
		case 3: col='id'; break;
	}
	_SIlinker_DBconn.executeSimpleSQL("update novels set updated=0 where "+col+"="+id);
	_SIlinkerSetTButton();
}

function _SIlinkerUpdateAuthor(id) {
	// update author
	
	_SIlinker_DBconn.executeSimpleSQL("update authors set checked=0 where id="+id);
	window.setTimeout(_SIlinkerJobStart,10);
}

function _SIlinkerUpdateSite(id) {
	// update all authors from site
	
	_SIlinker_DBconn.executeSimpleSQL("update authors set checked=0 where dom_id="+id);
	window.setTimeout(_SIlinkerJobStart,10);
}

function _SIlinkerUpdateAll() {
	// update all authors
	
	var idx=0;
	var data=_SIlinker_data;
	
	while(idx<data.length) {
		if((data[idx].level==0)&&(data[idx].pocket)) {
			var pocket=data[idx].pocket;
			var i=0;
			while(i<pocket.length) {
				if(pocket[i].level==1) pocket[i].updating=true;
				i++;
			}
		} else if(data[idx].level==1) {
			data[idx].updating=true;
			_SIlinkerUpdateView(idx,0,idx)
		}
		idx++;
	}

	_SIlinker_DBconn.executeSimpleSQL("update authors set checked=0");
	window.setTimeout(_SIlinkerJobStart,10);
}


function _SIlinkerRead(id,aBkg) {
	// open novel in si-reader by id

	var statement = _SIlinker_DBconn.createStatement("select domain||path||file as url from novels_urls where id="+id); 
	try {
		if(statement.executeStep()) {
			_SIlinkerOpenNovel("http://"+statement.getUTF8String(0),aBkg);
		}
	}
	finally {  
		statement.reset();  
	}  
}

function _SIlinkerOpenUpdated() {
	// open updated authors' pages
	
	var statement = _SIlinker_DBconn.createStatement("select domain||path from authors_list where (select sum(updated) from novels where novels.auth_id=authors_list.id)>0");
	try {
		while(statement.executeStep()) {
			_SIlinkerOpenTab('http://'+statement.getUTF8String(0)+'indexdate.shtml',true);
		}
	}
	finally {  
		statement.reset();  
	}  
}

function _SIlinkerGetSite(id) {
	// returns domain name by id
	
	var domain;
	var statement = _SIlinker_DBconn.createStatement("select domain from domains where id="+id);
	try {
		if(statement.executeStep()) {
			domain=statement.getUTF8String(0);
		}
	}
	finally {  
		statement.reset();  
	}
	
	return domain;
}

function _SIlinkerSetSite(id,domain) {
	// sets domain name by id
	
	_SIlinker_DBconn.executeSimpleSQL("update domains set domain='"+domain+"' where id="+id);
}

function _SIlinkerSetUrgent(lvl,id,urg,all) {
	// set urgent status

	urg = urg ? 1 : 0;
	_SIlinker_DBconn.beginTransaction();
	switch(lvl) {
		case 1:
			_SIlinker_DBconn.executeSimpleSQL("update authors set urgent="+urg+" where id="+id);
			if(all) {
				_SIlinker_DBconn.executeSimpleSQL("update folders set urgent="+urg+" where auth_id="+id);
				_SIlinker_DBconn.executeSimpleSQL("update novels set urgent="+urg+" where auth_id="+id);
			}
			break;
		case 2:
			_SIlinker_DBconn.executeSimpleSQL("update folders set urgent="+urg+" where id="+id);
			if(all) {
				_SIlinker_DBconn.executeSimpleSQL("update novels set urgent="+urg+" where fold_id="+id);
			}
			break;
		case 3:
			_SIlinker_DBconn.executeSimpleSQL("update novels set urgent="+urg+" where id="+id);
			break;
	}
	_SIlinker_DBconn.commitTransaction();	
}
